%% Hierarchical clustering (Examples)


%generate a 3 gaussian dataset

N=120;

 GA = [.4 0.6; 0.6 2];    GB = [2.5 -0.23; -0.23 .5]; GC =  [1 0; 0 1];
 G = cat(3,GA,GB,GC);
 U = dataset([0 1 ; 6 3 ; 4 -1],[1 2 3]');
 GG = gauss(N ,U,G);   
 
 [nl,llist]=dataset(GG); %% original labels

figure(1); scatterd(GG)

%%Using PRTOOLS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% different options
%tip='s'; %% single link
%tip='c'; %% complete link
tip='a'; %% average

D=distm(GG,GG)         %% distances

%%prtools
dg = hclust(D,tip);      %% clustering
figure(3); plotdg(dg);   %% dendrogram

%% see different solutions
for c=6:-1:1
 c 
 [l,dg] = hclust(D,tip,c );   %% c clusters
 GC=dataset(GG,l,'name',[getname(GG) ' -- ' num2str(c) ' clusters']);           %% relabel
 figure(2); scatterd(GC) 
 pause
end

disp('Statistical Toolbox')
pause

%%Using Statistical toolbox
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


d=pdist(+GG);         %% distances (lots of options)

X=linkage(d);     %% have a loot at the options !!!
                  %% singel linkage by default
%X=linkage(d,'average');
figure(4),dendrogram(X,'colorthreshold','default');

%% see different solutions
for c=6:-1:1
 c 
 t = cluster(X,'maxclust',c );   %% c clusters
 GC=dataset(GG,t,'name',[getname(GG) ' -- ' num2str(c) ' clusters']);           %% relabel
 figure(5); scatterd(GC) 
 pause
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Kmeans
[lab Res]=kmeans(GG,3);
figure(6),scatterd(Res)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fuzzy logic toolbox
[center,U,obj_fcn] = fcm(+GG,3);

[mm,lab]=max(U);

GC=dataset(GG,lab)
figure(7),scatterd(GC)
figure(8),plot(obj_fcn)



 
 